#ifndef bqCE_Elem_hh
#define bqCE_Elem_hh

#include "autoptr.hh"

typedef autoeqptr<class Elem> elemp;

class Elem : public ptrable
{
public:
	char type;
public:
	virtual ~Elem()
	{
	}
	
	virtual bool operator== (const Elem &e) const = 0;
	virtual bool operator< (const Elem &e) const = 0;
	
	Elem(char c=0) : type(c)
	{
	}
	
	virtual elemp Expand() = 0;
	virtual void Yksmuu(class Yksikkomuunnokset &how);
};

#endif
